# -*- coding: utf-8 -*-
import sys, json
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urlparse, urljoin
except ImportError:
    from urllib.parse import urlparse, urljoin
try:
    from urllib import urlencode, quote
except ImportError:
    from urllib.parse import urlencode, quote

# http://www.haituenter.com/
host = 'www.haitudy.com'


def getsoup(url):
    res = urlopen(url)
    cookie = res.info().get('Set-Cookie')
    if cookie:
        for e1 in cookie.split(';'):
            k, v = e1.split('=')
            if k.strip() == 'PHPSESSID':
                res.close()
                import time
                time.sleep(3)
                req = Request(url, headers={'Cookie': e1})
                res = urlopen(req)
    content = res.read().decode('utf-8-sig', 'ignore')
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(content, 'html.parser')
    return BeautifulSoup(content, 'html5lib')


def getjson(url, data=None):
    return json.loads(urlopen(url, data).read().decode('utf-8-sig'))


def category(cat, page=1):
    url = 'http://%s/%s/page/%d' % (host, cat, page)
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'haitum 200', 'error': str(e)}
    ret = []
    try:
        for e1 in soup.select('ul.new-list li a'):
            if 'href' not in e1.attrs:
                continue
            img = e1.img['_src']
            img = urljoin(url, img)
            plot = []
            for e2 in e1.select('span'):
                plot.append(e2.text)
            for e2 in e1.select('div p'):
                if 'class' in e2.attrs and e2['class'][0] == 'subject':
                    continue
                plot.append(e2.text)
            plot = '\n'.join(plot)
            ret.append({'title': e1['title'], 'url': urljoin(url, e1['href']), 'img': img, 'plot': plot})
    except Exception as e:
        return {'code': 'haitum 201', 'error': str(e)}
    if page < int(soup.select('div.count b.total_pages')[0].text):
        ret.append({'title': 'Next Page (%d)' % (page + 1), 'category': cat, 'page': page + 1})
    return ret


def search(s, page=1):
    if not s:
        return {'code': 'haitum 300'}
    url = 'http://%s/search/%s/page/%d' % (host, quote(s), page)
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'haitum 301', 'error': str(e)}
    ret = []
    try:
        for e1 in soup.select('ul.search-list li'):
            e2 = e1.select('div.txt h5 a')[0]
            img = e1.select('div.row div.img a img')[0]['_src']
            img = urljoin(url, img)
            plot = []
            for e3 in e1.select('div.txt p'):
                plot.append(e3.text)
            plot = '\n'.join(plot)
            ret.append({'title': e2.text, 'url': urljoin(url, e2['href']), 'img': img, 'plot': plot})
    except Exception as e:
        return {'code': 'haitum 302', 'error': str(e)}
    if page < int(soup.select('div.count b.total_pages')[0].text):
        ret.append({'title': 'Next Page (%d)' % (page + 1), 'search': s, 'page': page + 1})
    return ret


def movie(url, index=-1):
    url = url.replace('www.haitum.com', host)
    ret = []
    if index == -1:
        try:
            soup = getsoup(url)
        except Exception as e:
            return {'code': 'haitum 101', 'error': str(e)}
        img = soup.select('div.thumb img')[0] #['_src']
        if '_src' in img.attrs:
            img = img['_src']
        else:
            img = img['src']
        img = urljoin(url, img)
        try:
            i = 0
            for e1 in soup.select('div.item-wrap div.rb-item h5'):
                title = []
                for e2 in e1('a'):
                    title.append(e2.text)
                    e2.extract()
                title = ' '.join(title)
                for e2 in e1('b'):
                    e2.extract()
                title = e1.text.strip() + ' ' + title
                ret.append({'title': title, 'url': url, 'index': i, 'img': img})
                i += 1
        except Exception as e:
            return {'code': 'haitum 102', 'error': str(e)}
        return ret
    o = urlparse(url)
    p = o.path.split('/')
    assert p[2]
    if not p[2].endswith('.html'):
        return {'code': 'haitum 100'}
    p[2] = p[2][:-5]
    data = {
        'order': 'getTargetRsBoxData',
        'ids': p[2],
        'type': 0,
        'index': index
    }
    try:
        data = getjson('http://' + host + '/common/api_getTargetRsBoxData.php', urlencode(data).encode('utf-8'))
    except Exception as e:
        return {'code': 'haitum 111', 'error': str(e)}
    try:
        for e in data['data']['episodes']:
            o = urlparse(e['url'])
            p = o.path.split('/')
            ext = p[-1].split('.')[-1]
            if ext not in ('m3u', 'm3u8'):
                continue
            ret.append({'title': data['data']['provider'] + ' ' + e['title'], 'url': e['url']})
    except Exception as e:
        return {'code': 'haitum 112', 'error': str(e)}
    return ret
    # o = urlparse(url)
    # p = o.path.split('/')
    # assert p[2]
    # if p[2][-5:] != '.html':
    #     return {'code': 'haitum 100'}
    # p[2] = p[2][:-5]
    # p[2] = p[2].split('-')
    # if len(p[2]) != 2:
    #     return {'code': 'haitum 101'}
    # data = {
    #     'order': 'getNewHost',
    #     'aid': '',
    #     'sid': p[2][0],
    #     'mid': p[2][1],
    #     'isstatic': 1,
    #     'target': 'movieDetails',
    #     'rp0': index,
    #     'rp1': 0,
    #     'isBackServerRsData': 1
    # }
    # try:
    #     data = getjson('http://www.haitum.com/common/api_getNewHost.php', urlencode(data))
    # except Exception as e:
    #     return {'code': 'haitum 102', 'error': str(e)}
    # try:
    #     for e in data['data']['resource']['episodes']:
    #         ret.append({'title': e['title'], 'url': e['url']})
    # except:
    #     return {'code': 'haitum 103'}
    # return ret
